% Transforming the data into a coloumn vector consisting of V/V0 and
% pressure p, i.e. [VdivV0',p,]'. It also returns the length of each
% dataset

function [p, VdivV0, len] = pvdata_al2o3()

h1 = load('sato_and_akimoto_1979.txt');
h2 = load('grevel_and_burchard_etal_2000a.txt');
h3 = load('grevel_and_burchard_etal_2000b.txt');
h4 = load('hart_and_drickamer_1965.txt');
h5 = load('damour_and_schiferl_1978.txt');
h6 = load('richet_and_xu_etal_1988.txt');
h7 = load('marsh_1980.txt');
numDatasets = 7;

% Transforming into V/V0 since the data is given in V in some papers
%-----------------------------------------------------------------------
VdivV02 = zeros(length(h2(:,3)),1);
for i = 1:1:length(h2(:,3))
VdivV02(i,1) = h2(i,3)/h2(1,3); 
end   

VdivV03 = zeros(length(h3(:,3)),1);
for i = 1:1:length(h3(:,3))
VdivV03(i,1) = h3(i,3)/h3(1,3); 
end 

%-----------------------------------------------------------------------
% Combining into two vectors of p and VdivV0
p    = [h1(:,2)',h2(:,2)',h3(:,2)', h4(:,2)', ...
    h5(:,2)',h6(:,2)',h7(:,2)']';
gamma = 0.779/0.774; % gamma = Cp/Cv
h7(:,3)=h7(:,3).^gamma; 
VdivV0 = [h1(:,3)',VdivV02',VdivV03', h4(:,3)',...
    h5(:,3)',h6(:,3)',h7(:,3)']';
%------------------------------------------------------------------------
% Making a vector which contains the length of the different datasets
len = zeros(1,numDatasets);

len(1)      = length(h1(:,2));
len(2)      = length(h2(:,2))+length(h3(:,2));
len(3)      = length(h4(:,2));
len(4)      = length(h5(:,2));   
len(5)      = length(h6(:,2));
len(6)      = length(h7(:,2));

%-----------------------------------------------------------------------
