% Transforming the data into a coloumn vector consisting of V/V0 and
% pressure p, i.e. [VdivV0',p,]'. It also returns the length of each
% dataset

function [p, VdivV0, len] = pvdata_CaO()

h1 = load('perezalbuerne_drickamer_1965.txt');
h2 = load('speziale_shieh_etal_2006.txt');
h3 = load('mammone_and_mao_etal_1980.txt');
h4 = load('yamanaka_and_kittaka_etal_2002.txt');
h5 = load('richet_and_mao_etal_1988.txt');
numDatasets = 5;

% Transforming into V/V0 since the data is given in V in some papers
%-----------------------------------------------------------------------
% VdivV02 = zeros(length(h2(:,3)),1);
% for i = 1:1:length(h2(:,3))
% VdivV02(i,1) = h2(i,3)/h2(1,3); 
% end                                              

%-----------------------------------------------------------------------
% Combining into two vectors of p and VdivV0
p    = [h1(:,2)',h2(:,2)',h3(:,2)',h4(:,2)',h5(:,2)']';
VdivV0 = [h1(:,3)',h2(:,3)',h3(:,3)',h4(:,3)',h5(:,3)']';
%------------------------------------------------------------------------
% Making a vector which contains the length of the different datasets
len = zeros(1,numDatasets);

len(1)      = length(h1(:,2));
len(2)      = length(h2(:,2));
len(3)      = length(h3(:,2));
len(4)      = length(h4(:,2));
len(5)      = length(h5(:,2));

%-----------------------------------------------------------------------
