% Nonlinear least squares for a fitting curve on the form 
% log(V/V0) + 1/(K01*(a-b))*log((1+a*p)/(1+b*p)) = 0
% Here, x vector is [K01; K02; K03] 
% xdata is the reduced volume and pressure
% param is the extra input as a struct, accessed by param(1).xxxx

function [F, mean] = newcurve_res_MgCO3(x, xdata, param)

% K01 = 160.77; %165 % 160.77 %161.6
K01 = x(1);
K02 = x(2);
K03 = x(3);
n = length(xdata)/2;
m = length(xdata);
a = K02/(2*K01)*(1+sqrt(1-4*K03*K01/(K02^2)));
b = K02/K01-a;

F = log(xdata(1:n))+ 1/(K01*(a-b))*log((1+a*xdata(n+1:m))./(1+b*xdata(n+1:m)));
% Scale the function values with the variance, assume a linear variance
% with respect to pressure (empirically)
% F = F./(1e-4*(xdata(n+1:m)+1)+0.1); 
%--------------------------------------------------------------------
% Finding the mean for each experimental series and substract it
len = param.len;
mean = zeros(1,length(param.len)-1);
% for i = 1:length(len)-1
%  mean(i) = sum(F(1+len(i):len(i+1)))/(len(i+1)-len(i));
%  F(1+len(i):len(i+1)) = F(1+len(i):len(i+1))- mean(i);
% end
%--------------------------------------------------------------------
% Making the final matrix to be returned  
F = [F;zeros(size(F))];
