% Transforming the data into a coloumn vector consisting of V/V0 and
% pressure p, i.e. [VdivV0',p,]'. It also returns the length of each
% dataset

function [p, VdivV0, len] = pvdata_MgCO3()

h1 = load('ross_1997.txt');
h2 = load('fiquet_and_reynard_1999.txt');
numDatasets = 2;

% Transforming into V/V0 since the data is given in V in some papers
%-----------------------------------------------------------------------
VdivV0 = zeros(length(h1(:,3)),1);
for i = 1:1:length(h1(:,3))
VdivV0(i,1) = h1(i,3)/279.28; % given in the paper 
end           
VdivV02 = zeros(length(h2(:,3)),1);
for i = 1:1:length(h2(:,3))
VdivV02(i,1) = h2(i,3)/279.14; % given in the paper 
end      
%-----------------------------------------------------------------------
% Combining into two vectors of p and VdivV0
p    = [h1(:,2)',h2(:,2)']';%',h3(:,2)',h4(:,2)',h5(:,2)']';
% gamma = 0.868/0.822;
% h5(:,3) = h5(:,3);%.^gamma;
VdivV0 = [VdivV0',VdivV02']';%,h3(:,3)',h4(:,3)',h5(:,3)']';
%------------------------------------------------------------------------
% Making a vector which contains the length of the different datasets
len = zeros(1,numDatasets);

len(1)      = length(h1(:,2));
len(2)      = length(h2(:,2));

%-----------------------------------------------------------------------
