% Transforming the data into a coloumn vector consisting of V/V0 and
% pressure p, i.e. [VdivV0',p,]'. It also returns the length of each
% dataset

function [p, VdivV0, len] = pvdata_mgo()

h1 = load('Speziale_Zha_etal_2001.txt');
h2 = load('Mao_Bell_1979.txt');
h3 =load('PerezAlbuerne_Drickamer_1965.txt');
h4 =load('Li_Woody_etal_2006.txt');
h5 =load('Jacobsen_Holl_etal_2008a.txt');
h6 =load('Jacobsen_Holl_etal_2008b.txt');
h7 =load('Jacobsen_Holl_etal_2008c.txt');
h8 = load('LASL.txt');
numDatasets = 8;

% Transforming into V/V0 since the data is given in V in some papers
%-----------------------------------------------------------------------
VdivV02 = zeros(length(h1(:,3)),1);
for i = 1:1:length(h1(:,3))
VdivV02(i,1) = h1(i,3)/74.71; % 74.71 where given as V0 in Speziale..
end                                 

VdivV03 = zeros(length(h5(:,3)),1);
for i = 1:1:length(h5(:,3))
VdivV03(i,1) = h5(i,3)/74.698;
end

VdivV04 = zeros(length(h6(:,3)),1);
for i = 1:1:length(h6(:,3))
VdivV04(i,1) = h6(i,3)/74.698;
end

VdivV05 = zeros(length(h7(:,3)),1);
for i = 1:1:length(h7(:,3))
VdivV05(i,1) = h7(i,3)/74.698;
end

%-----------------------------------------------------------------------
% Combining into two vectors of p and VdivV0
p    = [h1(:,2)',h2(:,2)',h3(:,2)',h4(:,2)', h5(:,2)',...
    h6(:,2)',h7(:,2)',h8(:,2)']';
gamma = 0.928/0.915;
h8(:,3)=h8(:,3).^gamma; 
VdivV0 = [VdivV02', h2(:,3)',h3(:,3)',h4(:,3)', ...
        VdivV03', VdivV04',VdivV05', h8(:,3)']';

%------------------------------------------------------------------------
% Making a vector which contains the length of the different datasets
len = zeros(1,numDatasets);

len(1)      = length(h1(:,2));
len(2)      = length(h2(:,2));
len(3)      = length(h3(:,2));
len(4)      = length(h4(:,2))+length(h5(:,2))+length(h6(:,2));
len(5)      = length(h7(:,2));
len(6)      = length(h8(:,2));

%-----------------------------------------------------------------------

