% Test of NaCl data

clear all
clc

addpath(cd('..\'));
K01 =24.3804;
K02 =4.99712;
K03 =-0.0486765;
[p, VdivV0] = pvdata_NaCl();
x4 = [K01 K02 K03];
xdata4 = [VdivV0', p']';
F4 = returnf(x4,xdata4);
% Standarizing the data
stdav = sqrt(var(F4));
my = mean(F4);
Fsort4 = sort((F4-my)/stdav);
y4 = (1:length(F4))/length(F4);
plot(Fsort4,y4, '+')
clear path
hold on
% Plot the cumulative normal distribution
normdist = -3:0.1:3;
p1 = cdf('Normal',normdist,0,1);
plot(normdist,p1) 
bins2 = -2:0.5:2;
bins = [bins2,6];
cumE = 0;
cumO = 0;
O = zeros(10,1);
E = zeros(10,1);
for i = 1:10
O(i) = length(find(Fsort4<bins(i)))-cumO;
cumO = cumO+O(i);
E(i) = (p1(max(find(normdist<=bins(i))))-cumE);
cumE = cumE+E(i);
end
E = E*length(Fsort4);
Exp = zeros(length(E),1);
Obs = zeros(length(O),1);
for i = 1:length(E)/2
    if E(i)<5
        Exp(i+1)=Exp(i)+E(i);
        Obs(i+1)=Obs(i)+O(i);
        Exp(i)=0;
        Obs(i)=0;
    else
        Exp(i)=Exp(i)+E(i);
        Obs(i)=Obs(i)+O(i);
    end
end

for i = length(E)/2+1:length(E)
%     disp(i) 
    if E(i)<5
%         Exp(i-1)=Exp(i-1)+E(i);
        Exp(i)=0;
        Obs(i)=0;
     else
        Exp(i)=Exp(i)+E(i);
        Obs(i)=Obs(i)+O(i);
     end
end
Exp(8)=E(8)+E(10)+E(9);
Obs(8)=O(8)+O(10)+O(9);
for i = 1:length(Exp)
    if Exp(i)>0
        chi(i) = (Obs(i)-Exp(i))^2/(Exp(i));
    end
end
sumchi = sum(chi);
disp(sumchi)