% Transforming the data into a coloumn vector consisting of V/V0 and
% pressure p, i.e. [VdivV0',p,]'. It also returns the length of each
% dataset

function [p, VdivV0, len] = pvdata_NaCl()

h1 = load('satosorensen_1983.txt');
h2 = load('perezalbuerne_and_drickamer_1965.txt');
h3 = load('liu_and_basset_1972.txt');
h4 = load('birch_1986.txt');
h5 = load('LASL_NaCl.txt');
numDatasets = 5;
%-----------------------------------------------------------------------
% Combining into two vectors of p and VdivV0
p    = [h1(:,2)',h2(:,2)',h3(:,2)',h4(:,2)',h5(:,2)']';
VdivV0 = [h1(:,3)',h2(:,3)',h3(:,3)',h4(:,3)',h5(:,3)']';
%------------------------------------------------------------------------
% Making a vector which contains the length of the different datasets
len = zeros(1,numDatasets);

len(1)      = length(h1(:,2));
len(2)      = length(h2(:,2));
len(3)      = length(h3(:,2));
len(4)      = length(h4(:,2));
len(5)      = length(h5(:,2));
%-----------------------------------------------------------------------
