% Transforming the data into a coloumn vector consisting of V/V0 and
% pressure p, i.e. [VdivV0',p,]'. It also returns the length of each
% dataset

function [p, VdivV0, len] = pvdata_SiO2()

h1 = load('hazen_and_finger_etal_1989.txt');
h2 = load('olinger_and_halleck_1976.txt');
h3 = load('wackerle_1962.txt');
h4 = load('levien_and_prewitt_etal_1980.txt');
numDatasets = 4;

%-----------------------------------------------------------------------
% Combining into two vectors of p and VdivV0
p    = [h1(:,2)',h2(:,2)',h3(:,2)',h4(:,2)']';

VdivV0 = [h1(:,3)',h2(:,3)',h3(:,3)',h4(:,3)']';
%------------------------------------------------------------------------
% Making a vector which contains the length of the different datasets
len = zeros(1,numDatasets);

len(1)      = length(h1(:,2));
len(2)      = length(h2(:,2));
len(3)      = length(h3(:,2));
len(4)      = length(h4(:,2));
%-----------------------------------------------------------------------
