% Bootstrapping of data
clc
clear all
close all

% Getting the data for the solids, choose the path that is wanted
% and change the names for lsq and pvdata accordingly
% addpath('Al2O3')
addpath('MgO')
% addpath('NaCl')
% addpath('SiO2')
% addpath('CaO')
% addpath('MgCO3')

% The optimal values calculated from lsq

theta_opts = lsq_mgo();
close all

x0 = theta_opts; % Guesses for parameters

[p, VdivV0, len] = pvdata_mgo();
xdata = [VdivV0'; p']';
% xdata = [[VdivV0',VdivV0'];[p',p']]';
xdata2 = [VdivV0',p']';

nl = length(xdata)/2;
m = length(xdata);
%------------------------------------------------------------------------
% Making a vector, len2, which contains the number of measuring points in
% each series
len2 = zeros(1, length(len)+1);
for i = 2:length(len2)
  len2(i) = sum(len(1:i-1));
end

% Gives the extra option parameters, param, through a struct array
param = struct('len', len2);
%------------------------------------------------------------------------
n = length(xdata);       %size of each data set
nReps = 2000;  %number of data sets or 'experiments'
% myStat = @mean; % function handle which gives mean
id = randi(n,n,nReps);
bootstrapData = zeros(n,2,nReps); % size 220, 2, 2000
for i = 1:nReps
   bootstrapData(:,:,i) = xdata(id(:,i),:); % Gives all the different
end                                         %bootstrapdata


xdata_new = zeros(2*n,1);
ydata = zeros(size(xdata_new));
x = zeros(nReps,length(x0));
for i = 1:nReps
    xdata_new = bootstrapData(:,:,i);
    xdata_f   = [xdata_new(:,1)',xdata_new(:,2)']'; % Rearranging  
    f = @(x,xdata)residual(x,xdata,param);          % to getting
    x(i,:) = lsqcurvefit(f,x0,xdata_f,ydata);       % the correct form
end

for i = 1:length(x)
    if imag(x(i,:))~= 0
        x(i,1)=theta_opts(1);
        x(i,2)=theta_opts(2);
        x(i,3)=theta_opts(3);
    end
end
theta_opt = zeros(nReps, length(x0));
for i = 1:nReps
  theta_opt(i,:)=theta_opts;
end
% cov(theta)=E[(theta-theta_opt)(theta-theta_opt)']
covtheta = zeros(3,3);
covtheta(1,1) = mean((x(:,1)-theta_opt(:,1)).*((x(:,1)-theta_opt(:,1))));
covtheta(1,2) = mean((x(:,1)-theta_opt(:,1)).*((x(:,2)-theta_opt(:,2))));
covtheta(1,3) = mean((x(:,1)-theta_opt(:,1)).*((x(:,3)-theta_opt(:,3))));
covtheta(2,1) = mean((x(:,2)-theta_opt(:,2)).*((x(:,1)-theta_opt(:,1))));
covtheta(2,2) = mean((x(:,2)-theta_opt(:,2)).*((x(:,2)-theta_opt(:,2))));
covtheta(2,3) = mean((x(:,2)-theta_opt(:,2)).*((x(:,3)-theta_opt(:,3))));
covtheta(3,1) = mean((x(:,3)-theta_opt(:,3)).*((x(:,1)-theta_opt(:,1))));
covtheta(3,2) = mean((x(:,3)-theta_opt(:,3)).*((x(:,2)-theta_opt(:,2))));
covtheta(3,3) = mean((x(:,3)-theta_opt(:,3)).*((x(:,3)-theta_opt(:,3))));

[Q2,L2] = eig(covtheta);
F = returnf(x0,xdata2);
s2 = 1/((length(F)-length(x0)))*(F'*F); % Residual sum of squares

B = Q2*sqrt(L2);

Imat = inv(B)*Q2*L2*Q2'*inv(B)';

k = x*(Q2*diag(1./(sqrt(diag(L2)))));
k_opt = theta_opt*(Q2*diag(1./(sqrt(diag(L2)))));
covkappa = zeros(3,3);
covkappa(1,1) = mean((k(:,1)-k_opt(:,1)).*((k(:,1)-k_opt(:,1))));
covkappa(1,2) = mean((k(:,1)-k_opt(:,1)).*((k(:,2)-k_opt(:,2))));
covkappa(1,3) = mean((k(:,1)-k_opt(:,1)).*((k(:,3)-k_opt(:,3))));
covkappa(2,1) = mean((k(:,2)-k_opt(:,2)).*((k(:,1)-k_opt(:,1))));
covkappa(2,2) = mean((k(:,2)-k_opt(:,2)).*((k(:,2)-k_opt(:,2))));
covkappa(2,3) = mean((k(:,2)-k_opt(:,2)).*((k(:,3)-k_opt(:,3))));
covkappa(3,1) = mean((k(:,3)-k_opt(:,3)).*((k(:,1)-k_opt(:,1))));
covkappa(3,2) = mean((k(:,3)-k_opt(:,3)).*((k(:,2)-k_opt(:,2))));
covkappa(3,3) = mean((k(:,3)-k_opt(:,3)).*((k(:,3)-k_opt(:,3))));

% disp(covkappa);

dtheta = zeros(3,3);
dtheta(:,1)=B*(k_opt(1,:)+[1 0 0])'-theta_opt(1,:)';
dtheta(:,2)=B*(k_opt(1,:)+[0 1 0])'-theta_opt(1,:)';
dtheta(:,3)=B*(k_opt(1,:)+[0 0 1])'-theta_opt(1,:)';

fprintf('std1 = [%f; %f; %f];\n',dtheta(1,1),dtheta(2,1) , dtheta(3,1))
fprintf('std2 = [%f; %f; %f];\n',dtheta(1,2),dtheta(2,2) , dtheta(3,2))
fprintf('std3 = [%f; %f; %f];\n',dtheta(1,3),dtheta(2,3) , dtheta(3,3))

%------------------------------------------------------------------
% Making a contour plot for K02 and K03 to find if a minimum exists, and if
% so where it exists
K01 = k_opt(1);
K02 = linspace(145,400,100);
K03 = linspace(-25,-150,100);
Y = zeros(length(K02), length(K03));
for i = 1:length(K02)
    for j = 1:length(K03)
        k01 = B(1,:)*[K01;K02(i);K03(j)];
        k02 = B(2,:)*[K01;K02(i);K03(j)];
        k03 = B(3,:)*[K01;K02(i);K03(j)];
        a = k02/(2*k01)*(1+sqrt(1-4*k03*k01/(k02^2)));
        b = k02/k01-a;
        y = (log(VdivV0) + 1/(k01*(a-b))*log((1+a*p)./(1+b*p)));
        Y(i,j) = sqrt(y'*y);
    end
end
Y(Y>3*min(min(Y))) = NaN;

% Plotting the contour plot
% subplot(2,1,2)
figure(4)
vector2 = 0:0.02:0.1;
contour(K03,K02,Y-min(min(Y)),vector2)
% title('Contour plot for MgO')
xlabel('\kappa{}_3')
ylabel('\kappa{}_2')