% Numerical first order differentials of my implicit function with respect
% to the parameters

function g = numdiff(x, xdata,dtheta)

K01 = x(1);
K02 = x(2);
K03 = x(3);

dtheta1 = dtheta(1);
x(1) = K01 + dtheta1;
F2 = returnf(x, xdata);
x(1) = K01 - dtheta1;
F1 = returnf(x, xdata);
x(1) = K01; % Return to its original value
g(1) = (norm(F2)-norm(F1))/(2*dtheta1); 
% g(1) = norm((F2-F1)/(2*dtheta1));

dtheta2 = dtheta(2);
x(2) = K02 + dtheta2;
F4 = returnf(x, xdata);
x(2) = K02 - dtheta2;
F3 = returnf(x, xdata);
x(2) = K02; % Return to its original value
g(2) = (norm(F4)-norm(F3))/(2*dtheta2); 

dtheta3 = dtheta(3);
x(3) = K03 + dtheta3;
F6 = returnf(x, xdata);
x(3) = K03 - dtheta3;
F5 = returnf(x, xdata);
g(3) = (norm(F6)-norm(F5))/(2*dtheta3); 