% Numerical second order differentials of my implicit function with respect
% to the parameters

function H = numdiff2(x, xdata, dtheta)

K01 = x(1);
K02 = x(2);
K03 = x(3);
dtheta1 = dtheta(1);
dtheta2 = dtheta(2);
dtheta3 = dtheta(3);

H = zeros(3,3);

% Element 1,1 d2f/d1d1
element = 1;
H(:,1) = hessian(x,xdata,K01,dtheta1,element);

element = 2;
H(:,2) = hessian(x,xdata,K02,dtheta2,element);

element = 3;
H(:,3) = hessian(x,xdata,K03,dtheta3,element);

H = 0.5*(H+H');